/*--------------------------------------------------------------------+
|                                                                     |
|    STDIO.H - Standard I/O Definitions Header File for Atari ST      |
|                                                                     |
+--------------------------------------------------------------------*/

#nolist

/* SIGNED type pseudonyms */

#define   LONG      int
#define   WORD      short int
#define   BYTE      char

/* UNSIGNED type pseudonyms */

#define   ULONG     unsigned int
#define   UWORD     unsigned short int
#define   UBYTE     unsigned char

/* Definitions to aid program readability */

#define   FILE      int                 
#define   BOOLEAN   short int
#define   FOREVER   while ( 1 )

/* BOOLEAN values */

#define   YES       1
#define   NO        0
#define   ON        1
#define   OFF       0
#define   TRUE      1
#define   FALSE     0

/* STATUS codes */

#define   OK        0
#define   EOF       ( -1 )
#define   ERR       ( -2 )

/* CHARACTER codes */

#define   NULL      0
#define   BELL      7
#define   NL        10
#define   SPACE     32

/* Standard I/O CHANNELS */

extern LONG *stdin, *stdout, *stderr;

#list

